/*
** ۤ
*/
#include <cstdlib>
#include <cmath>
#if defined(WIN32)
#  include "glew.h"
#  include <GL/gl.h>
#elif defined(__APPLE__) || defined(MACOSX)
#  include <OpenGL/gl.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/gl.h>
#endif

#include "disseminate.h"

/* ĺХåե֥ȤΥ򻲾Ȥݥ󥿤Υǡ */
typedef GLfloat Point[3];

/*
** ֤˻ۤ
*/
GLuint disseminate(int points, const GLuint *buffer)
{
  /* ĺХåե֥Ȥͭˤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);

  /* ĺХåե֥Ȥ˥ΰݤ */
  glBufferData(GL_ARRAY_BUFFER, sizeof (Point) * points, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Point *point = (Point *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺΰ */
  for (int i = 0; i < points; ++i) {
    float r = sqrt(2.0f * (float)rand() / ((float)RAND_MAX + 1.0f));
    float t = 6.283185f * (float)rand() / ((float)RAND_MAX + 1.0f);
    (*point)[0] = r * cos(t);
    (*point)[1] = r * sin(t);
    (*point)[2] = (float)rand() / ((float)RAND_MAX + 1.0f);
    ++point;
  }

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  return points;
}
